]> git.madduck.net Git - code/myrepos.git/blobdiff - mr

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

don't abs_path($ENV{MR_CONFIG})
[code/myrepos.git] / mr
diff --git a/mr b/mr
index 44fb671e856749684eff8f98b4a7ed9ac2c270dd..53f7a068c9b437efd249a1de87f9699aab4db459 100755 (executable)
--- a/mr
+++ b/mr
@@ -204,7 +204,7 @@ A few parameters have special meanings:
 
 =item skip
 
-If the "skip" parameter is set and its command returns nonzero, then B<mr>
+If the "skip" parameter is set and its command returns true, then B<mr>
 will skip acting on that repository. The command is passed the action
 name in $1.
 
@@ -218,13 +218,13 @@ been at least 12 hours since the last update.
 
 =item chain
 
-If the "chain" parameter is set and its command returns nonzero, then B<mr>
+If the "chain" parameter is set and its command returns true, then B<mr>
 will try to load a .mrconfig file from the root of the repository. (You
 should avoid chaining from repositories with untrusted committers.)
 
 =item deleted
 
-If the "deleted" parameter is set and its command returns nonzero, then
+If the "deleted" parameter is set and its command returns true, then
 B<mr> will treat the repository as deleted. It won't ever actually delete
 the repository, but it will warn if it sees the repository's directory.
 This is useful when one mrconfig file is shared amoung multiple machines,
@@ -272,7 +272,7 @@ my %alias;
 Getopt::Long::Configure("no_permute");
 my $result=GetOptions(
        "d|directory=s" => sub { $directory=abs_path($_[1]) },
-       "c|config=s" => sub { $ENV{MR_CONFIG}=abs_path($_[1]) },
+       "c|config=s" => \$ENV{MR_CONFIG},
        "v|verbose" => \$verbose,
        "s|stats" => \$stats,
        "n|no-recurse" => \$no_recurse,
@@ -283,6 +283,13 @@ if (! $result || @ARGV < 1) {
 
 }
 
+# Make sure MR_CONFIG is an absolute path, but don't use abs_path since
+# the config file might be a symlink to elsewhere, and the directory it's
+# in is significant.
+if ($ENV{MR_CONFIG} !~ /^\//) {
+       $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
+}
+
 loadconfig(\*DATA);
 loadconfig($ENV{MR_CONFIG});
 #use Data::Dumper;
@@ -325,6 +332,8 @@ elsif ($action eq 'config') {
        if ($section=~/^\//) {
                # try to convert to a path relative to the config file
                my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
+               $dir=abs_path($dir);
+               $dir.="/" unless $dir=~/\/$/;
                if ($section=~/^\Q$dir\E(.*)/) {
                        $section=$1;
                }
@@ -404,26 +413,28 @@ sub action { #{{{
                        $config{$topdir}{$subdir}{lib}."\n" : "";
 
        if (exists $config{$topdir}{$subdir}{deleted}) {
-               if (! -d $dir) {
-                       return;
+               my $test="set -e;".$lib.$config{$topdir}{$subdir}{deleted};
+               print "mr $action: running deleted test >>$test<<\n" if $verbose;
+               my $ret=system($test);
+               if ($ret != 0) {
+                       if (($? & 127) == 2) {
+                               print STDERR "mr $action: interrupted\n";
+                               exit 2;
+                       }
+                       elsif ($? & 127) {
+                               print STDERR "mr $action: deleted test received signal ".($? & 127)."\n";
+                       }
                }
-               else {
-                       my $test="set -e;".$lib.$config{$topdir}{$subdir}{deleted};
-                       print "mr $action: running deleted test >>$test<<\n" if $verbose;
-                       my $ret=system($test);
-                       if ($ret != 0) {
-                               if (($? & 127) == 2) {
-                                       print STDERR "mr $action: interrupted\n";
-                                       exit 2;
-                               }
-                               elsif ($? & 127) {
-                                       print STDERR "mr $action: deleted test received signal ".($? & 127)."\n";
-                               }
-                               if ($ret >> 8 == 0) {
-                                       print STDERR "mr error: $dir should be deleted yet still exists\n\n";
-                                       push @failed, $dir;
-                                       return;
-                               }
+               if ($ret >> 8 == 0) {
+                       if (-d $dir) {
+                               print STDERR "mr error: $dir should be deleted yet still exists\n\n";
+                               push @failed, $dir;
+                               return;
+                       }
+                       else {
+                               print "mr $action: $dir skipped (as deleted) per config file\n" if $verbose;
+                               push @skipped, $dir;
+                               return;
                        }
                }
        }
@@ -464,11 +475,11 @@ sub action { #{{{
                                print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
                                exit 1;
                        }
-                       if ($ret >> 8 == 0) {
-                               print "mr $action: $dir skipped per config file\n" if $verbose;
-                               push @skipped, $dir;
-                               return;
-                       }
+               }
+               if ($ret >> 8 == 0) {
+                       print "mr $action: $dir skipped per config file\n" if $verbose;
+                       push @skipped, $dir;
+                       return;
                }
        }
        
@@ -885,6 +896,15 @@ register =
                fi
                echo "Registering bzr url: $url"
                mr -c "$MR_CONFIG" config "$(pwd)" checkout="bzr clone $url $basedir"
+       elif [ -d CVS ]; then
+               repo=$(cat CVS/Repository)
+               root=$(cat CVS/Root)
+               if [ -z "$root" ]; then
+                       error "cannot determine cvs root"
+               fi
+               echo "Registering cvs repository $repo at root $root"
+               mr -c "$MR_CONFIG" config "$(pwd)" \
+                       checkout="cvs -d '$root' co -d $basedir $repo"
        else
                error "unable to register this repo type"
        fi